> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.shipbob.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.shipbob.com/_mcp/server.

# Updates multiple product variants


PATCH https://api.shipbob.com/Experimental/product/{productId}/variants
Content-Type: application/json

Reference: https://developer.shipbob.com/experimental/api/products/updates-multiple-product-variants

## Authentication

- `Authorization` header (bearer token, required) — Authentication using Personal Access Token (PAT) token
- `Authorization` header (bearer token, required) — OAuth2 authentication using JWT tokens

## Servers

- `https://api.shipbob.com` (https://api.shipbob.com, default)
- `https://sandbox-api.shipbob.com` (https://sandbox-api.shipbob.com)

## Request

### Path parameters

- `productId` (long, required)

### Body (application/json)

This endpoint expects an object.

- `additional_hazmat_attributes` (object, optional)
  - `charge_state_percentage` (double, optional, nullable)
  - `container_metal` (boolean, optional, nullable)
  - `lithium_battery_packaging` (string, optional, nullable)
  - `lithium_battery_type` (string, optional, nullable)
  - `magnet` (boolean, optional, nullable)
  - `net_volume` (double, optional, nullable)
  - `net_weight` (double, optional, nullable)
- `barcodes` (list of object, optional, nullable)
  - `sticker_url` (string, optional, nullable)
  - `value` (string, optional, nullable)
- `bundle_definition` (list of object, optional, nullable)
  - `quantity` (integer, optional)
  - `variant_id` (long, optional)
- `channel_metadata` (list of object or object or object or object, optional, nullable)
  - Products.AmazonProductChannelMetadataModel
    - `asin` (string, optional, nullable)
    - `channel_id` (long, optional)
    - `channel_name` (string, optional, nullable)
    - `currency` (string, optional, nullable)
    - `fnsku` (string, optional, nullable)
    - `fulfillment_channel` (string, optional, nullable)
    - `id` (long, optional, nullable)
    - `is_inventory_sync_enabled` (boolean, optional)
    - `legacy_product_id` (long, optional, nullable)
    - `platform` (string, optional, nullable)
    - `platform_identifier` (string, optional, nullable)
    - `platform_inventory_item_id` (string, optional, nullable)
    - `price` (double, optional)
    - `seller_sku` (string, optional, nullable)
  - Products.BaseProductChannelMetadataModel
    - `channel_id` (long, optional)
    - `channel_name` (string, optional, nullable)
    - `currency` (string, optional, nullable)
    - `id` (long, optional, nullable)
    - `is_inventory_sync_enabled` (boolean, optional)
    - `legacy_product_id` (long, optional, nullable)
    - `platform` (string, optional, nullable)
    - `platform_identifier` (string, optional, nullable)
    - `platform_inventory_item_id` (string, optional, nullable)
    - `price` (double, optional)
    - `seller_sku` (string, optional, nullable)
  - Products.BigCommerceProductChannelMetadataModel
    - `channel_id` (long, optional)
    - `channel_name` (string, optional, nullable)
    - `currency` (string, optional, nullable)
    - `id` (long, optional, nullable)
    - `is_inventory_sync_enabled` (boolean, optional)
    - `legacy_product_id` (long, optional, nullable)
    - `platform` (string, optional, nullable)
    - `platform_identifier` (string, optional, nullable)
    - `platform_inventory_item_id` (string, optional, nullable)
    - `platform_product_id` (long, optional, nullable)
    - `platform_variant_id` (long, optional, nullable)
    - `price` (double, optional)
    - `seller_sku` (string, optional, nullable)
  - Products.ShopifyProductChannelMetadataModel
- `customs` (object, optional)
  - `country_code_of_origin` (string, optional, nullable)
  - `currency` (string, optional, nullable)
  - `description` (string, optional, nullable)
  - `hs_tariff_code` (string, optional, nullable)
  - `is321_eligible` (boolean, optional)
  - `value` (integer, optional, nullable)
- `dimension` (object, optional)
  - `height` (double, optional)
  - `length` (double, optional)
  - `width` (double, optional)
- `fulfillment_settings` (object, optional)
  - `dangerous_goods` (boolean, optional)
  - `is_bpm_parcel` (boolean, optional)
  - `is_case_pick` (boolean, optional)
  - `msds_url` (string, optional, nullable)
  - `requires_prop65` (boolean, optional)
  - `serial_scan` (object, optional)
    - `exact_character_length` (integer, optional, nullable)
    - `is_enabled` (boolean, optional)
    - `prefix` (string, optional, nullable)
    - `suffix` (string, optional, nullable)
- `gtin` (string, optional, nullable)
- `id` (long, optional)
- `is_digital` (boolean, optional)
- `lot_information` (object, optional)
  - `is_lot` (boolean, optional)
  - `minimum_shelf_life_days` (integer, optional, nullable)
- `name` (string, optional, nullable)
- `packaging_material_type_id` (integer, optional, nullable)
- `packaging_requirement_id` (integer, optional, nullable)
- `return_preferences` (object, optional)
  - `backup_action_id` (integer, optional, nullable)
  - `instructions` (string, optional, nullable)
  - `primary_action_id` (integer, optional)
  - `return_to_sender_backup_action_id` (integer, optional, nullable)
  - `return_to_sender_primary_action_id` (integer, optional, nullable)
- `reviews_pending` (list of enum, optional, nullable)
  - Allowed values: `0`, `1`, `2`, `3`, `4`
- `sku` (string, optional, nullable)
- `status` (enum, optional)
  - Allowed values: `1`, `2`, `3`
- `upc` (string, optional, nullable)
- `weight` (double, optional)

## Response

### 200

Success

- `list of object`
  - `additional_hazmat_attributes` (object, optional)
    - `charge_state_percentage` (double, optional, nullable)
    - `container_metal` (boolean, optional, nullable)
    - `lithium_battery_packaging` (string, optional, nullable)
    - `lithium_battery_type` (string, optional, nullable)
    - `magnet` (boolean, optional, nullable)
    - `net_volume` (double, optional, nullable)
    - `net_weight` (double, optional, nullable)
  - `associated_bundles` (list of object, optional, nullable)
    - `product_id` (long, optional)
    - `product_name` (string, optional, nullable)
    - `quantity` (integer, optional)
    - `variant_id` (long, optional)
    - `variant_sku` (string, optional, nullable)
  - `barcodes` (list of object, optional, nullable)
    - `sticker_url` (string, optional, nullable)
    - `value` (string, optional, nullable)
  - `bundle_definition` (list of object, optional, nullable)
    - `product_id` (long, optional)
    - `quantity` (integer, optional)
    - `variant_id` (long, optional)
    - `variant_name` (string, optional, nullable)
    - `variant_sku` (string, optional, nullable)
  - `channel_metadata` (list of object or object or object or object, optional, nullable)
    - Products.ChannelMetadataViewModel
      - `channel_id` (long, optional)
      - `channel_name` (string, optional, nullable)
      - `currency` (string, optional, nullable)
      - `id` (long, optional)
      - `is_inventory_sync_enabled` (boolean, optional)
      - `legacy_product_id` (long, optional, nullable)
      - `platform` (string, optional, nullable)
      - `platform_identifier` (string, optional, nullable)
      - `platform_inventory_item_id` (string, optional, nullable)
      - `price` (double, optional)
      - `seller_sku` (string, optional, nullable)
    - Products.AmazonChannelMetadataViewModel
      - `asin` (string, optional, nullable)
      - `channel_id` (long, optional)
      - `channel_name` (string, optional, nullable)
      - `currency` (string, optional, nullable)
      - `fnsku` (string, optional, nullable)
      - `fulfillment_channel` (string, optional, nullable)
      - `id` (long, optional)
      - `is_inventory_sync_enabled` (boolean, optional)
      - `legacy_product_id` (long, optional, nullable)
      - `platform` (string, optional, nullable)
      - `platform_identifier` (string, optional, nullable)
      - `platform_inventory_item_id` (string, optional, nullable)
      - `price` (double, optional)
      - `seller_sku` (string, optional, nullable)
    - Products.BigCommerceChannelMetadataViewModel
      - `channel_id` (long, optional)
      - `channel_name` (string, optional, nullable)
      - `currency` (string, optional, nullable)
      - `id` (long, optional)
      - `is_inventory_sync_enabled` (boolean, optional)
      - `legacy_product_id` (long, optional, nullable)
      - `platform` (string, optional, nullable)
      - `platform_identifier` (string, optional, nullable)
      - `platform_inventory_item_id` (string, optional, nullable)
      - `platform_product_id` (long, optional, nullable)
      - `platform_variant_id` (long, optional, nullable)
      - `price` (double, optional)
      - `seller_sku` (string, optional, nullable)
    - Products.ShopifyChannelMetadataViewModel
      - `channel_id` (long, optional)
      - `channel_name` (string, optional, nullable)
      - `currency` (string, optional, nullable)
      - `id` (long, optional)
      - `is_inventory_sync_enabled` (boolean, optional)
      - `legacy_product_id` (long, optional, nullable)
      - `platform` (string, optional, nullable)
      - `platform_identifier` (string, optional, nullable)
      - `platform_inventory_item_id` (string, optional, nullable)
      - `price` (double, optional)
      - `seller_sku` (string, optional, nullable)
  - `created_on` (datetime, optional)
  - `customs` (object, optional)
    - `country_code_of_origin` (string, optional, nullable)
    - `currency` (string, optional, nullable)
    - `description` (string, optional, nullable)
    - `hs_tariff_code` (string, optional, nullable)
    - `is321_eligible` (boolean, optional)
    - `value` (integer, optional, nullable)
  - `dimension` (object, optional)
    - `height` (double, optional)
    - `is_locked` (boolean, optional)
    - `length` (double, optional)
    - `source` (string, optional, nullable)
    - `unit` (string, optional, nullable)
    - `width` (double, optional)
  - `fulfillment_settings` (object, optional)
    - `dangerous_goods` (boolean, optional)
    - `is_bpm_parcel` (boolean, optional)
    - `is_case_pick` (boolean, optional)
    - `msds_url` (string, optional, nullable)
    - `requires_prop65` (boolean, optional)
    - `serial_scan` (object, optional)
      - `exact_character_length` (integer, optional, nullable)
      - `is_enabled` (boolean, optional)
      - `prefix` (string, optional, nullable)
      - `suffix` (string, optional, nullable)
  - `gtin` (string, optional, nullable)
  - `id` (long, optional)
  - `inventory` (object, optional)
    - `inventory_id` (integer, optional, nullable)
    - `on_hand_qty` (integer, optional)
  - `is_digital` (boolean, optional)
  - `is_image_uploaded` (boolean, optional)
  - `lot_information` (object, optional)
    - `is_lot` (boolean, optional)
    - `minimum_shelf_life_days` (integer, optional, nullable)
  - `merge_children` (list of object, optional, nullable)
    - `channel_ids` (list of long, optional, nullable)
    - `completed_at` (datetime, optional)
    - `inventory_id` (long, optional, nullable)
    - `variant_id` (long, optional)
    - `variant_name` (string, optional, nullable)
  - `name` (string, optional, nullable)
  - `packaging_material_type` (object, optional)
    - `id` (long, optional)
    - `name` (string, optional, nullable)
  - `packaging_requirement` (object, optional)
    - `id` (long, optional)
    - `name` (string, optional, nullable)
  - `return_preferences` (object, optional)
    - `backup_action` (object, optional)
      - `id` (long, optional)
      - `name` (string, optional, nullable)
    - `instructions` (string, optional, nullable)
    - `primary_action` (object, optional)
      - `id` (long, optional)
      - `name` (string, optional, nullable)
    - `return_to_sender_backup_action` (object, optional)
      - `id` (long, optional)
      - `name` (string, optional, nullable)
    - `return_to_sender_primary_action` (object, optional)
      - `id` (long, optional)
      - `name` (string, optional, nullable)
  - `reviews_pending` (list of string, optional, nullable)
  - `sku` (string, optional, nullable)
  - `status` (string, optional, nullable)
  - `upc` (string, optional, nullable)
  - `updated_on` (datetime, optional, nullable)
  - `weight` (object, optional)
    - `unit` (string, optional, nullable)
    - `weight` (double, optional)

## Examples

**Request**

```json
{
  "additional_hazmat_attributes": {
    "charge_state_percentage": 0.1,
    "container_metal": true,
    "lithium_battery_packaging": "string",
    "lithium_battery_type": "string",
    "magnet": true,
    "net_volume": 0.1,
    "net_weight": 0.1
  },
  "barcodes": [
    {
      "sticker_url": "string",
      "value": "string"
    }
  ],
  "bundle_definition": [
    {
      "quantity": 0,
      "variant_id": 0
    }
  ],
  "channel_metadata": [
    {
      "asin": "string",
      "fnsku": "string",
      "fulfillment_channel": "string",
      "channel_id": 0,
      "channel_name": "string",
      "currency": "string",
      "id": 0,
      "is_inventory_sync_enabled": true,
      "legacy_product_id": 0,
      "platform": "string",
      "platform_identifier": "string",
      "platform_inventory_item_id": "string",
      "price": 0.1,
      "seller_sku": "string"
    }
  ],
  "customs": {
    "country_code_of_origin": "string",
    "currency": "string",
    "description": "string",
    "hs_tariff_code": "string",
    "is321_eligible": true,
    "value": 0
  },
  "dimension": {
    "height": 0.1,
    "length": 0.1,
    "width": 0.1
  },
  "fulfillment_settings": {
    "dangerous_goods": true,
    "is_bpm_parcel": true,
    "is_case_pick": true,
    "msds_url": "string",
    "requires_prop65": true,
    "serial_scan": {
      "exact_character_length": 0,
      "is_enabled": true,
      "prefix": "string",
      "suffix": "string"
    }
  },
  "gtin": "string",
  "id": 0,
  "is_digital": true,
  "lot_information": {
    "is_lot": true,
    "minimum_shelf_life_days": 0
  },
  "name": "string",
  "packaging_material_type_id": 0,
  "packaging_requirement_id": 0,
  "return_preferences": {
    "backup_action_id": 0,
    "instructions": "string",
    "primary_action_id": 0,
    "return_to_sender_backup_action_id": 0,
    "return_to_sender_primary_action_id": 0
  },
  "reviews_pending": [
    0
  ],
  "sku": "string",
  "status": 1,
  "upc": "string",
  "weight": 0.1
}
```

**Response**

```json
[
  {
    "additional_hazmat_attributes": {
      "charge_state_percentage": 0.1,
      "container_metal": true,
      "lithium_battery_packaging": "string",
      "lithium_battery_type": "string",
      "magnet": true,
      "net_volume": 0.1,
      "net_weight": 0.1
    },
    "associated_bundles": [
      {
        "product_id": 0,
        "product_name": "string",
        "quantity": 0,
        "variant_id": 0,
        "variant_sku": "string"
      }
    ],
    "barcodes": [
      {
        "sticker_url": "string",
        "value": "string"
      }
    ],
    "bundle_definition": [
      {
        "product_id": 0,
        "quantity": 0,
        "variant_id": 0,
        "variant_name": "string",
        "variant_sku": "string"
      }
    ],
    "channel_metadata": [
      {
        "channel_id": 0,
        "channel_name": "string",
        "currency": "string",
        "id": 0,
        "is_inventory_sync_enabled": true,
        "legacy_product_id": 0,
        "platform": "string",
        "platform_identifier": "string",
        "platform_inventory_item_id": "string",
        "price": 0.1,
        "seller_sku": "string"
      }
    ],
    "created_on": "2019-08-24T14:15:22+00:00",
    "customs": {
      "country_code_of_origin": "string",
      "currency": "string",
      "description": "string",
      "hs_tariff_code": "string",
      "is321_eligible": true,
      "value": 0
    },
    "dimension": {
      "height": 0.1,
      "is_locked": true,
      "length": 0.1,
      "source": "string",
      "unit": "string",
      "width": 0.1
    },
    "fulfillment_settings": {
      "dangerous_goods": true,
      "is_bpm_parcel": true,
      "is_case_pick": true,
      "msds_url": "string",
      "requires_prop65": true,
      "serial_scan": {
        "exact_character_length": 0,
        "is_enabled": true,
        "prefix": "string",
        "suffix": "string"
      }
    },
    "gtin": "string",
    "id": 0,
    "inventory": {
      "inventory_id": 0,
      "on_hand_qty": 0
    },
    "is_digital": true,
    "is_image_uploaded": true,
    "lot_information": {
      "is_lot": true,
      "minimum_shelf_life_days": 0
    },
    "merge_children": [
      {
        "channel_ids": [
          0
        ],
        "completed_at": "2019-08-24T14:15:22+00:00",
        "inventory_id": 0,
        "variant_id": 0,
        "variant_name": "string"
      }
    ],
    "name": "string",
    "packaging_material_type": {
      "id": 0,
      "name": "string"
    },
    "packaging_requirement": {
      "id": 0,
      "name": "string"
    },
    "return_preferences": {
      "backup_action": {
        "id": 0,
        "name": "string"
      },
      "instructions": "string",
      "primary_action": {
        "id": 0,
        "name": "string"
      },
      "return_to_sender_backup_action": {
        "id": 0,
        "name": "string"
      },
      "return_to_sender_primary_action": {
        "id": 0,
        "name": "string"
      }
    },
    "reviews_pending": [
      "string"
    ],
    "sku": "string",
    "status": "string",
    "upc": "string",
    "updated_on": "2019-08-24T14:15:22+00:00",
    "weight": {
      "unit": "string",
      "weight": 0.1
    }
  }
]
```

**SDK Code**

```python default
import requests

url = "https://api.shipbob.com/Experimental/product/1/variants"

payload = {
    "additional_hazmat_attributes": {
        "charge_state_percentage": 0.1,
        "container_metal": True,
        "lithium_battery_packaging": "string",
        "lithium_battery_type": "string",
        "magnet": True,
        "net_volume": 0.1,
        "net_weight": 0.1
    },
    "barcodes": [
        {
            "sticker_url": "string",
            "value": "string"
        }
    ],
    "bundle_definition": [
        {
            "quantity": 0,
            "variant_id": 0
        }
    ],
    "channel_metadata": [
        {
            "asin": "string",
            "fnsku": "string",
            "fulfillment_channel": "string",
            "channel_id": 0,
            "channel_name": "string",
            "currency": "string",
            "id": 0,
            "is_inventory_sync_enabled": True,
            "legacy_product_id": 0,
            "platform": "string",
            "platform_identifier": "string",
            "platform_inventory_item_id": "string",
            "price": 0.1,
            "seller_sku": "string"
        }
    ],
    "customs": {
        "country_code_of_origin": "string",
        "currency": "string",
        "description": "string",
        "hs_tariff_code": "string",
        "is321_eligible": True,
        "value": 0
    },
    "dimension": {
        "height": 0.1,
        "length": 0.1,
        "width": 0.1
    },
    "fulfillment_settings": {
        "dangerous_goods": True,
        "is_bpm_parcel": True,
        "is_case_pick": True,
        "msds_url": "string",
        "requires_prop65": True,
        "serial_scan": {
            "exact_character_length": 0,
            "is_enabled": True,
            "prefix": "string",
            "suffix": "string"
        }
    },
    "gtin": "string",
    "id": 0,
    "is_digital": True,
    "lot_information": {
        "is_lot": True,
        "minimum_shelf_life_days": 0
    },
    "name": "string",
    "packaging_material_type_id": 0,
    "packaging_requirement_id": 0,
    "return_preferences": {
        "backup_action_id": 0,
        "instructions": "string",
        "primary_action_id": 0,
        "return_to_sender_backup_action_id": 0,
        "return_to_sender_primary_action_id": 0
    },
    "reviews_pending": [0],
    "sku": "string",
    "status": 1,
    "upc": "string",
    "weight": 0.1
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript default
const url = 'https://api.shipbob.com/Experimental/product/1/variants';
const options = {
  method: 'PATCH',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"additional_hazmat_attributes":{"charge_state_percentage":0.1,"container_metal":true,"lithium_battery_packaging":"string","lithium_battery_type":"string","magnet":true,"net_volume":0.1,"net_weight":0.1},"barcodes":[{"sticker_url":"string","value":"string"}],"bundle_definition":[{"quantity":0,"variant_id":0}],"channel_metadata":[{"asin":"string","fnsku":"string","fulfillment_channel":"string","channel_id":0,"channel_name":"string","currency":"string","id":0,"is_inventory_sync_enabled":true,"legacy_product_id":0,"platform":"string","platform_identifier":"string","platform_inventory_item_id":"string","price":0.1,"seller_sku":"string"}],"customs":{"country_code_of_origin":"string","currency":"string","description":"string","hs_tariff_code":"string","is321_eligible":true,"value":0},"dimension":{"height":0.1,"length":0.1,"width":0.1},"fulfillment_settings":{"dangerous_goods":true,"is_bpm_parcel":true,"is_case_pick":true,"msds_url":"string","requires_prop65":true,"serial_scan":{"exact_character_length":0,"is_enabled":true,"prefix":"string","suffix":"string"}},"gtin":"string","id":0,"is_digital":true,"lot_information":{"is_lot":true,"minimum_shelf_life_days":0},"name":"string","packaging_material_type_id":0,"packaging_requirement_id":0,"return_preferences":{"backup_action_id":0,"instructions":"string","primary_action_id":0,"return_to_sender_backup_action_id":0,"return_to_sender_primary_action_id":0},"reviews_pending":[0],"sku":"string","status":1,"upc":"string","weight":0.1}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go default
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.shipbob.com/Experimental/product/1/variants"

	payload := strings.NewReader("{\n  \"additional_hazmat_attributes\": {\n    \"charge_state_percentage\": 0.1,\n    \"container_metal\": true,\n    \"lithium_battery_packaging\": \"string\",\n    \"lithium_battery_type\": \"string\",\n    \"magnet\": true,\n    \"net_volume\": 0.1,\n    \"net_weight\": 0.1\n  },\n  \"barcodes\": [\n    {\n      \"sticker_url\": \"string\",\n      \"value\": \"string\"\n    }\n  ],\n  \"bundle_definition\": [\n    {\n      \"quantity\": 0,\n      \"variant_id\": 0\n    }\n  ],\n  \"channel_metadata\": [\n    {\n      \"asin\": \"string\",\n      \"fnsku\": \"string\",\n      \"fulfillment_channel\": \"string\",\n      \"channel_id\": 0,\n      \"channel_name\": \"string\",\n      \"currency\": \"string\",\n      \"id\": 0,\n      \"is_inventory_sync_enabled\": true,\n      \"legacy_product_id\": 0,\n      \"platform\": \"string\",\n      \"platform_identifier\": \"string\",\n      \"platform_inventory_item_id\": \"string\",\n      \"price\": 0.1,\n      \"seller_sku\": \"string\"\n    }\n  ],\n  \"customs\": {\n    \"country_code_of_origin\": \"string\",\n    \"currency\": \"string\",\n    \"description\": \"string\",\n    \"hs_tariff_code\": \"string\",\n    \"is321_eligible\": true,\n    \"value\": 0\n  },\n  \"dimension\": {\n    \"height\": 0.1,\n    \"length\": 0.1,\n    \"width\": 0.1\n  },\n  \"fulfillment_settings\": {\n    \"dangerous_goods\": true,\n    \"is_bpm_parcel\": true,\n    \"is_case_pick\": true,\n    \"msds_url\": \"string\",\n    \"requires_prop65\": true,\n    \"serial_scan\": {\n      \"exact_character_length\": 0,\n      \"is_enabled\": true,\n      \"prefix\": \"string\",\n      \"suffix\": \"string\"\n    }\n  },\n  \"gtin\": \"string\",\n  \"id\": 0,\n  \"is_digital\": true,\n  \"lot_information\": {\n    \"is_lot\": true,\n    \"minimum_shelf_life_days\": 0\n  },\n  \"name\": \"string\",\n  \"packaging_material_type_id\": 0,\n  \"packaging_requirement_id\": 0,\n  \"return_preferences\": {\n    \"backup_action_id\": 0,\n    \"instructions\": \"string\",\n    \"primary_action_id\": 0,\n    \"return_to_sender_backup_action_id\": 0,\n    \"return_to_sender_primary_action_id\": 0\n  },\n  \"reviews_pending\": [\n    0\n  ],\n  \"sku\": \"string\",\n  \"status\": 1,\n  \"upc\": \"string\",\n  \"weight\": 0.1\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby default
require 'uri'
require 'net/http'

url = URI("https://api.shipbob.com/Experimental/product/1/variants")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"additional_hazmat_attributes\": {\n    \"charge_state_percentage\": 0.1,\n    \"container_metal\": true,\n    \"lithium_battery_packaging\": \"string\",\n    \"lithium_battery_type\": \"string\",\n    \"magnet\": true,\n    \"net_volume\": 0.1,\n    \"net_weight\": 0.1\n  },\n  \"barcodes\": [\n    {\n      \"sticker_url\": \"string\",\n      \"value\": \"string\"\n    }\n  ],\n  \"bundle_definition\": [\n    {\n      \"quantity\": 0,\n      \"variant_id\": 0\n    }\n  ],\n  \"channel_metadata\": [\n    {\n      \"asin\": \"string\",\n      \"fnsku\": \"string\",\n      \"fulfillment_channel\": \"string\",\n      \"channel_id\": 0,\n      \"channel_name\": \"string\",\n      \"currency\": \"string\",\n      \"id\": 0,\n      \"is_inventory_sync_enabled\": true,\n      \"legacy_product_id\": 0,\n      \"platform\": \"string\",\n      \"platform_identifier\": \"string\",\n      \"platform_inventory_item_id\": \"string\",\n      \"price\": 0.1,\n      \"seller_sku\": \"string\"\n    }\n  ],\n  \"customs\": {\n    \"country_code_of_origin\": \"string\",\n    \"currency\": \"string\",\n    \"description\": \"string\",\n    \"hs_tariff_code\": \"string\",\n    \"is321_eligible\": true,\n    \"value\": 0\n  },\n  \"dimension\": {\n    \"height\": 0.1,\n    \"length\": 0.1,\n    \"width\": 0.1\n  },\n  \"fulfillment_settings\": {\n    \"dangerous_goods\": true,\n    \"is_bpm_parcel\": true,\n    \"is_case_pick\": true,\n    \"msds_url\": \"string\",\n    \"requires_prop65\": true,\n    \"serial_scan\": {\n      \"exact_character_length\": 0,\n      \"is_enabled\": true,\n      \"prefix\": \"string\",\n      \"suffix\": \"string\"\n    }\n  },\n  \"gtin\": \"string\",\n  \"id\": 0,\n  \"is_digital\": true,\n  \"lot_information\": {\n    \"is_lot\": true,\n    \"minimum_shelf_life_days\": 0\n  },\n  \"name\": \"string\",\n  \"packaging_material_type_id\": 0,\n  \"packaging_requirement_id\": 0,\n  \"return_preferences\": {\n    \"backup_action_id\": 0,\n    \"instructions\": \"string\",\n    \"primary_action_id\": 0,\n    \"return_to_sender_backup_action_id\": 0,\n    \"return_to_sender_primary_action_id\": 0\n  },\n  \"reviews_pending\": [\n    0\n  ],\n  \"sku\": \"string\",\n  \"status\": 1,\n  \"upc\": \"string\",\n  \"weight\": 0.1\n}"

response = http.request(request)
puts response.read_body
```

```java default
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://api.shipbob.com/Experimental/product/1/variants")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"additional_hazmat_attributes\": {\n    \"charge_state_percentage\": 0.1,\n    \"container_metal\": true,\n    \"lithium_battery_packaging\": \"string\",\n    \"lithium_battery_type\": \"string\",\n    \"magnet\": true,\n    \"net_volume\": 0.1,\n    \"net_weight\": 0.1\n  },\n  \"barcodes\": [\n    {\n      \"sticker_url\": \"string\",\n      \"value\": \"string\"\n    }\n  ],\n  \"bundle_definition\": [\n    {\n      \"quantity\": 0,\n      \"variant_id\": 0\n    }\n  ],\n  \"channel_metadata\": [\n    {\n      \"asin\": \"string\",\n      \"fnsku\": \"string\",\n      \"fulfillment_channel\": \"string\",\n      \"channel_id\": 0,\n      \"channel_name\": \"string\",\n      \"currency\": \"string\",\n      \"id\": 0,\n      \"is_inventory_sync_enabled\": true,\n      \"legacy_product_id\": 0,\n      \"platform\": \"string\",\n      \"platform_identifier\": \"string\",\n      \"platform_inventory_item_id\": \"string\",\n      \"price\": 0.1,\n      \"seller_sku\": \"string\"\n    }\n  ],\n  \"customs\": {\n    \"country_code_of_origin\": \"string\",\n    \"currency\": \"string\",\n    \"description\": \"string\",\n    \"hs_tariff_code\": \"string\",\n    \"is321_eligible\": true,\n    \"value\": 0\n  },\n  \"dimension\": {\n    \"height\": 0.1,\n    \"length\": 0.1,\n    \"width\": 0.1\n  },\n  \"fulfillment_settings\": {\n    \"dangerous_goods\": true,\n    \"is_bpm_parcel\": true,\n    \"is_case_pick\": true,\n    \"msds_url\": \"string\",\n    \"requires_prop65\": true,\n    \"serial_scan\": {\n      \"exact_character_length\": 0,\n      \"is_enabled\": true,\n      \"prefix\": \"string\",\n      \"suffix\": \"string\"\n    }\n  },\n  \"gtin\": \"string\",\n  \"id\": 0,\n  \"is_digital\": true,\n  \"lot_information\": {\n    \"is_lot\": true,\n    \"minimum_shelf_life_days\": 0\n  },\n  \"name\": \"string\",\n  \"packaging_material_type_id\": 0,\n  \"packaging_requirement_id\": 0,\n  \"return_preferences\": {\n    \"backup_action_id\": 0,\n    \"instructions\": \"string\",\n    \"primary_action_id\": 0,\n    \"return_to_sender_backup_action_id\": 0,\n    \"return_to_sender_primary_action_id\": 0\n  },\n  \"reviews_pending\": [\n    0\n  ],\n  \"sku\": \"string\",\n  \"status\": 1,\n  \"upc\": \"string\",\n  \"weight\": 0.1\n}")
  .asString();
```

```php default
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://api.shipbob.com/Experimental/product/1/variants', [
  'body' => '{
  "additional_hazmat_attributes": {
    "charge_state_percentage": 0.1,
    "container_metal": true,
    "lithium_battery_packaging": "string",
    "lithium_battery_type": "string",
    "magnet": true,
    "net_volume": 0.1,
    "net_weight": 0.1
  },
  "barcodes": [
    {
      "sticker_url": "string",
      "value": "string"
    }
  ],
  "bundle_definition": [
    {
      "quantity": 0,
      "variant_id": 0
    }
  ],
  "channel_metadata": [
    {
      "asin": "string",
      "fnsku": "string",
      "fulfillment_channel": "string",
      "channel_id": 0,
      "channel_name": "string",
      "currency": "string",
      "id": 0,
      "is_inventory_sync_enabled": true,
      "legacy_product_id": 0,
      "platform": "string",
      "platform_identifier": "string",
      "platform_inventory_item_id": "string",
      "price": 0.1,
      "seller_sku": "string"
    }
  ],
  "customs": {
    "country_code_of_origin": "string",
    "currency": "string",
    "description": "string",
    "hs_tariff_code": "string",
    "is321_eligible": true,
    "value": 0
  },
  "dimension": {
    "height": 0.1,
    "length": 0.1,
    "width": 0.1
  },
  "fulfillment_settings": {
    "dangerous_goods": true,
    "is_bpm_parcel": true,
    "is_case_pick": true,
    "msds_url": "string",
    "requires_prop65": true,
    "serial_scan": {
      "exact_character_length": 0,
      "is_enabled": true,
      "prefix": "string",
      "suffix": "string"
    }
  },
  "gtin": "string",
  "id": 0,
  "is_digital": true,
  "lot_information": {
    "is_lot": true,
    "minimum_shelf_life_days": 0
  },
  "name": "string",
  "packaging_material_type_id": 0,
  "packaging_requirement_id": 0,
  "return_preferences": {
    "backup_action_id": 0,
    "instructions": "string",
    "primary_action_id": 0,
    "return_to_sender_backup_action_id": 0,
    "return_to_sender_primary_action_id": 0
  },
  "reviews_pending": [
    0
  ],
  "sku": "string",
  "status": 1,
  "upc": "string",
  "weight": 0.1
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp default
using RestSharp;

var client = new RestClient("https://api.shipbob.com/Experimental/product/1/variants");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"additional_hazmat_attributes\": {\n    \"charge_state_percentage\": 0.1,\n    \"container_metal\": true,\n    \"lithium_battery_packaging\": \"string\",\n    \"lithium_battery_type\": \"string\",\n    \"magnet\": true,\n    \"net_volume\": 0.1,\n    \"net_weight\": 0.1\n  },\n  \"barcodes\": [\n    {\n      \"sticker_url\": \"string\",\n      \"value\": \"string\"\n    }\n  ],\n  \"bundle_definition\": [\n    {\n      \"quantity\": 0,\n      \"variant_id\": 0\n    }\n  ],\n  \"channel_metadata\": [\n    {\n      \"asin\": \"string\",\n      \"fnsku\": \"string\",\n      \"fulfillment_channel\": \"string\",\n      \"channel_id\": 0,\n      \"channel_name\": \"string\",\n      \"currency\": \"string\",\n      \"id\": 0,\n      \"is_inventory_sync_enabled\": true,\n      \"legacy_product_id\": 0,\n      \"platform\": \"string\",\n      \"platform_identifier\": \"string\",\n      \"platform_inventory_item_id\": \"string\",\n      \"price\": 0.1,\n      \"seller_sku\": \"string\"\n    }\n  ],\n  \"customs\": {\n    \"country_code_of_origin\": \"string\",\n    \"currency\": \"string\",\n    \"description\": \"string\",\n    \"hs_tariff_code\": \"string\",\n    \"is321_eligible\": true,\n    \"value\": 0\n  },\n  \"dimension\": {\n    \"height\": 0.1,\n    \"length\": 0.1,\n    \"width\": 0.1\n  },\n  \"fulfillment_settings\": {\n    \"dangerous_goods\": true,\n    \"is_bpm_parcel\": true,\n    \"is_case_pick\": true,\n    \"msds_url\": \"string\",\n    \"requires_prop65\": true,\n    \"serial_scan\": {\n      \"exact_character_length\": 0,\n      \"is_enabled\": true,\n      \"prefix\": \"string\",\n      \"suffix\": \"string\"\n    }\n  },\n  \"gtin\": \"string\",\n  \"id\": 0,\n  \"is_digital\": true,\n  \"lot_information\": {\n    \"is_lot\": true,\n    \"minimum_shelf_life_days\": 0\n  },\n  \"name\": \"string\",\n  \"packaging_material_type_id\": 0,\n  \"packaging_requirement_id\": 0,\n  \"return_preferences\": {\n    \"backup_action_id\": 0,\n    \"instructions\": \"string\",\n    \"primary_action_id\": 0,\n    \"return_to_sender_backup_action_id\": 0,\n    \"return_to_sender_primary_action_id\": 0\n  },\n  \"reviews_pending\": [\n    0\n  ],\n  \"sku\": \"string\",\n  \"status\": 1,\n  \"upc\": \"string\",\n  \"weight\": 0.1\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift default
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "additional_hazmat_attributes": [
    "charge_state_percentage": 0.1,
    "container_metal": true,
    "lithium_battery_packaging": "string",
    "lithium_battery_type": "string",
    "magnet": true,
    "net_volume": 0.1,
    "net_weight": 0.1
  ],
  "barcodes": [
    [
      "sticker_url": "string",
      "value": "string"
    ]
  ],
  "bundle_definition": [
    [
      "quantity": 0,
      "variant_id": 0
    ]
  ],
  "channel_metadata": [
    [
      "asin": "string",
      "fnsku": "string",
      "fulfillment_channel": "string",
      "channel_id": 0,
      "channel_name": "string",
      "currency": "string",
      "id": 0,
      "is_inventory_sync_enabled": true,
      "legacy_product_id": 0,
      "platform": "string",
      "platform_identifier": "string",
      "platform_inventory_item_id": "string",
      "price": 0.1,
      "seller_sku": "string"
    ]
  ],
  "customs": [
    "country_code_of_origin": "string",
    "currency": "string",
    "description": "string",
    "hs_tariff_code": "string",
    "is321_eligible": true,
    "value": 0
  ],
  "dimension": [
    "height": 0.1,
    "length": 0.1,
    "width": 0.1
  ],
  "fulfillment_settings": [
    "dangerous_goods": true,
    "is_bpm_parcel": true,
    "is_case_pick": true,
    "msds_url": "string",
    "requires_prop65": true,
    "serial_scan": [
      "exact_character_length": 0,
      "is_enabled": true,
      "prefix": "string",
      "suffix": "string"
    ]
  ],
  "gtin": "string",
  "id": 0,
  "is_digital": true,
  "lot_information": [
    "is_lot": true,
    "minimum_shelf_life_days": 0
  ],
  "name": "string",
  "packaging_material_type_id": 0,
  "packaging_requirement_id": 0,
  "return_preferences": [
    "backup_action_id": 0,
    "instructions": "string",
    "primary_action_id": 0,
    "return_to_sender_backup_action_id": 0,
    "return_to_sender_primary_action_id": 0
  ],
  "reviews_pending": [0],
  "sku": "string",
  "status": 1,
  "upc": "string",
  "weight": 0.1
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.shipbob.com/Experimental/product/1/variants")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```